searchData={"items":[{"type":"module","title":"Spooks","doc":"Documentation for `Spooks`.\n\nSee `Spooks.Workflow` for information on how to make an agentic workflow.\n\nSee `Spooks.WorkflowEngine` for information on how to run an agentic workflow.","ref":"Spooks.html"},{"type":"module","title":"Spooks.Checkpoint.SpookCheckpoints","doc":"Logic for handling checkpoints (saving and retrieving the state of agent workflows) in Spooks.\n\nRight now Ecto is the only supported repository for checkpoints.","ref":"Spooks.Checkpoint.SpookCheckpoints.html"},{"type":"function","title":"Spooks.Checkpoint.SpookCheckpoints.checkpoints_enabled?/1","doc":"Checks if checkpoints are enabled for the given context.","ref":"Spooks.Checkpoint.SpookCheckpoints.html#checkpoints_enabled?/1"},{"type":"function","title":"Spooks.Checkpoint.SpookCheckpoints.get_checkpoint/1","doc":"Gets the checkpoint for the given context. Returns nil if there is no checkpoint.","ref":"Spooks.Checkpoint.SpookCheckpoints.html#get_checkpoint/1"},{"type":"function","title":"Spooks.Checkpoint.SpookCheckpoints.get_checkpoint_event/1","doc":"After retrieving a checkpoint from the database we must convert its data back into a struct.","ref":"Spooks.Checkpoint.SpookCheckpoints.html#get_checkpoint_event/1"},{"type":"function","title":"Spooks.Checkpoint.SpookCheckpoints.get_workflow_context/1","doc":"After retrieving a checkpoint from the database we must convert its data back into a struct.","ref":"Spooks.Checkpoint.SpookCheckpoints.html#get_workflow_context/1"},{"type":"function","title":"Spooks.Checkpoint.SpookCheckpoints.has_checkpoint?/1","doc":"Checks if there is a checkpoint for the given context.","ref":"Spooks.Checkpoint.SpookCheckpoints.html#has_checkpoint?/1"},{"type":"function","title":"Spooks.Checkpoint.SpookCheckpoints.remove_checkpoint/1","doc":"Removes the checkpoint for the given context.","ref":"Spooks.Checkpoint.SpookCheckpoints.html#remove_checkpoint/1"},{"type":"function","title":"Spooks.Checkpoint.SpookCheckpoints.save_checkpoint/2","doc":"Saves a checkpoint for the given context and event.","ref":"Spooks.Checkpoint.SpookCheckpoints.html#save_checkpoint/2"},{"type":"module","title":"Spooks.Context.SpooksContext","doc":"","ref":"Spooks.Context.SpooksContext.html"},{"type":"function","title":"Spooks.Context.SpooksContext.get_data/2","doc":"Function for getting your custom data from the context.","ref":"Spooks.Context.SpooksContext.html#get_data/2"},{"type":"function","title":"Spooks.Context.SpooksContext.new/4","doc":"Creates a new context struct, prefer this over initizializing the struct directly.","ref":"Spooks.Context.SpooksContext.html#new/4"},{"type":"function","title":"Spooks.Context.SpooksContext.put_data/3","doc":"Function for putting your custom data into the context.","ref":"Spooks.Context.SpooksContext.html#put_data/3"},{"type":"module","title":"Spooks.Context.Step","doc":"","ref":"Spooks.Context.Step.html"},{"type":"module","title":"Spooks.Event.EndEvent","doc":"","ref":"Spooks.Event.EndEvent.html"},{"type":"module","title":"Spooks.Event.StartEvent","doc":"","ref":"Spooks.Event.StartEvent.html"},{"type":"module","title":"Spooks.Sample.HumanInputEvent","doc":"","ref":"Spooks.Sample.HumanInputEvent.html"},{"type":"module","title":"Spooks.Sample.SampleWorkflow","doc":"","ref":"Spooks.Sample.SampleWorkflow.html"},{"type":"function","title":"Spooks.Sample.SampleWorkflow.end_step/2","doc":"","ref":"Spooks.Sample.SampleWorkflow.html#end_step/2"},{"type":"function","title":"Spooks.Sample.SampleWorkflow.human_input_step/2","doc":"","ref":"Spooks.Sample.SampleWorkflow.html#human_input_step/2"},{"type":"function","title":"Spooks.Sample.SampleWorkflow.start_step/2","doc":"","ref":"Spooks.Sample.SampleWorkflow.html#start_step/2"},{"type":"function","title":"Spooks.Sample.SampleWorkflow.step_four_step/2","doc":"","ref":"Spooks.Sample.SampleWorkflow.html#step_four_step/2"},{"type":"function","title":"Spooks.Sample.SampleWorkflow.step_one_step/2","doc":"","ref":"Spooks.Sample.SampleWorkflow.html#step_one_step/2"},{"type":"function","title":"Spooks.Sample.SampleWorkflow.step_three_step/2","doc":"","ref":"Spooks.Sample.SampleWorkflow.html#step_three_step/2"},{"type":"function","title":"Spooks.Sample.SampleWorkflow.step_two_step/2","doc":"","ref":"Spooks.Sample.SampleWorkflow.html#step_two_step/2"},{"type":"function","title":"Spooks.Sample.SampleWorkflow.steps/0","doc":"","ref":"Spooks.Sample.SampleWorkflow.html#steps/0"},{"type":"module","title":"Spooks.Sample.StepFourEvent","doc":"","ref":"Spooks.Sample.StepFourEvent.html"},{"type":"module","title":"Spooks.Sample.StepOneEvent","doc":"","ref":"Spooks.Sample.StepOneEvent.html"},{"type":"module","title":"Spooks.Sample.StepThreeEvent","doc":"","ref":"Spooks.Sample.StepThreeEvent.html"},{"type":"module","title":"Spooks.Sample.StepTwoEvent","doc":"","ref":"Spooks.Sample.StepTwoEvent.html"},{"type":"module","title":"Spooks.Schema.WorkflowCheckpoint","doc":"","ref":"Spooks.Schema.WorkflowCheckpoint.html"},{"type":"function","title":"Spooks.Schema.WorkflowCheckpoint.create_changeset/2","doc":"","ref":"Spooks.Schema.WorkflowCheckpoint.html#create_changeset/2"},{"type":"function","title":"Spooks.Schema.WorkflowCheckpoint.update_changeset/2","doc":"","ref":"Spooks.Schema.WorkflowCheckpoint.html#update_changeset/2"},{"type":"module","title":"Spooks.SpooksAgentRunner","doc":"The SpooksAgentsRunner module is responsible for running agentic workflows.","ref":"Spooks.SpooksAgentRunner.html"},{"type":"function","title":"Spooks.SpooksAgentRunner.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\n`arg` is passed as the argument to `Task.start_link/1` in the `:start` field\nof the spec.\n\nFor more information, see the `Supervisor` module,\nthe `Supervisor.child_spec/2` function and the `t:Supervisor.child_spec/0` type.","ref":"Spooks.SpooksAgentRunner.html#child_spec/1"},{"type":"function","title":"Spooks.SpooksAgentRunner.run/5","doc":"Checks for jobs that need to be killed ON THIS NODE and tries to kill them.","ref":"Spooks.SpooksAgentRunner.html#run/5"},{"type":"function","title":"Spooks.SpooksAgentRunner.start_link/1","doc":"Starts the SpooksAgentsRunner task with the provided options. This task should be run on each node.\n\nThe repo is required for agents that save their state to checkpoints.\nThe run time is the number of seconds between checks for agents to run. It is OPTIONAL and defaults to 60 minutes.","ref":"Spooks.SpooksAgentRunner.html#start_link/1"},{"type":"module","title":"Spooks.SpooksCheckpointRunner","doc":"The SpooksCheckpointRunner module is responsible for running agentic workflows.","ref":"Spooks.SpooksCheckpointRunner.html"},{"type":"function","title":"Spooks.SpooksCheckpointRunner.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\n`arg` is passed as the argument to `Task.start_link/1` in the `:start` field\nof the spec.\n\nFor more information, see the `Supervisor` module,\nthe `Supervisor.child_spec/2` function and the `t:Supervisor.child_spec/0` type.","ref":"Spooks.SpooksCheckpointRunner.html#child_spec/1"},{"type":"function","title":"Spooks.SpooksCheckpointRunner.get_expired_checkpoints/1","doc":"","ref":"Spooks.SpooksCheckpointRunner.html#get_expired_checkpoints/1"},{"type":"function","title":"Spooks.SpooksCheckpointRunner.get_timed_out_checkpoints/2","doc":"","ref":"Spooks.SpooksCheckpointRunner.html#get_timed_out_checkpoints/2"},{"type":"function","title":"Spooks.SpooksCheckpointRunner.run/3","doc":"Checks for checkpoints that need to be resumed ON THIS NODE and tries to resume them.","ref":"Spooks.SpooksCheckpointRunner.html#run/3"},{"type":"function","title":"Spooks.SpooksCheckpointRunner.start_link/1","doc":"Starts the SpooksCheckpointRunner task with the provided options. This task should be run on each node.\n\nThe repo is required for agents that saved their state to checkpoints and have timed out.\nThe check time is the number of seconds between checks for agents to run. It is OPTIONAL and defaults to 60 minutes.\nThe agent timeout is the number of minutes after which an agent checkpoint is considered stale. It is OPTIONAL and defaults to 60 minutes.","ref":"Spooks.SpooksCheckpointRunner.html#start_link/1"},{"type":"module","title":"Spooks.SpooksMermaidDiagrams","doc":"Module for generating mermaid diagrams from a workflow module.\n\nYou need to have mermaid.js included in your project to render the diagrams. Add it using your package manager (npm, yarn, poetry, etc).\n\nYou also need a live view javascript hook to render the diagrams.\nIn `hooks.js` you can add the following code:\n\n```javascript\nimport mermaid from \"mermaid\";\n\nlet Hooks = {  }\n\nHooks.Mermaid = {\n  mounted() {\n    this.renderMermaid();\n  },\n  updated() {\n    this.renderMermaid();\n  },\n  renderMermaid() {\n    mermaid.run(undefined, this.el.querySelectorAll('.mermaid'));\n  }\n};\n\nexport default Hooks\n```\nThen in your heex files you can include the diagram like this:\n\nExample:\n     \n       \n         \n          <%= @diagram_text %>","ref":"Spooks.SpooksMermaidDiagrams.html"},{"type":"function","title":"Spooks.SpooksMermaidDiagrams.get_spooks_diagram_text/1","doc":"Generates a mermaid diagram from a workflow module.\n\nExample:\n    iex> Spooks.SpooksMermaidDiagrams.get_spooks_diagram_text(Spooks.Sample.SampleWorkflow)","ref":"Spooks.SpooksMermaidDiagrams.html#get_spooks_diagram_text/1"},{"type":"function","title":"Spooks.SpooksMermaidDiagrams.get_spooks_diagram_text_from_steps/1","doc":"Generates a mermaid diagram from a list of steps.\nYou can get the steps from a workflow by calling the steps function on the workflow.\n\nExample:\n    iex> steps = Spooks.Sample.SampleWorkflow.steps()\n    iex> Spooks.SpooksMermaidDiagrams.get_spooks_diagram_text_from_steps(steps)","ref":"Spooks.SpooksMermaidDiagrams.html#get_spooks_diagram_text_from_steps/1"},{"type":"module","title":"Spooks.Workflow","doc":"","ref":"Spooks.Workflow.html"},{"type":"macro","title":"Spooks.Workflow.__using__/1","doc":"Add `use Spooks.Workflow` to your workflow module to enable the `@step` attribute.","ref":"Spooks.Workflow.html#__using__/1"},{"type":"macro","title":"Example - Spooks.Workflow.__using__/1","doc":"defmodule MyWorkflow do\n      use Spooks.Workflow\n\n      @step %Step{in: StartEvent, out: StepOneEvent}\n      def start_step(%StartEvent{} = start_event, %SpooksContext{} = ctx) do\n        {:ok, ctx, %StepOneEvent{}}\n      end\n    end","ref":"Spooks.Workflow.html#__using__/1-example"},{"type":"module","title":"Spooks.WorkflowEngine","doc":"The Spooks Workflow Engine is responsible for running agentic workflows.\n\nA workflow context is also provided that contains information about how the workflow engine should run.\nThe context holds the workflow module, the repository (required if using checkpoints), and an optional llm that can be used by the workflow agent steps.\n\nThere is an event that is passed to each step in the workflow. This event name is used to determine the step function that is called.\nThe function returns a new event which determines the next step in the workflow.","ref":"Spooks.WorkflowEngine.html"},{"type":"module","title":"Example - Spooks.WorkflowEngine","doc":"ctx = Spooks.Context.SpooksContext.new(Spooks.Sample.SampleWorkflow, nil)\n    Spooks.WorkflowEngine.run_workflow(ctx)","ref":"Spooks.WorkflowEngine.html#module-example"},{"type":"function","title":"Spooks.WorkflowEngine.get_step_function_name/1","doc":"Gets the name of the step function for the given event.","ref":"Spooks.WorkflowEngine.html#get_step_function_name/1"},{"type":"function","title":"Spooks.WorkflowEngine.resume_workflow/1","doc":"Resumes a workflow for the given context. Uses the last checkpoint to determine the next step.\n\nIf there is no checkpoint, it will raise an error.","ref":"Spooks.WorkflowEngine.html#resume_workflow/1"},{"type":"function","title":"Spooks.WorkflowEngine.run_step/2","doc":"Runs a step in the workflow for the given context.\n\nIf the step returns an event, it will save a checkpoint and run the next step.\nIf the step returns nil, it will remove the checkpoint and end the workflow.\n\nIf the step function does not exist in the workflow module, it will raise an error.","ref":"Spooks.WorkflowEngine.html#run_step/2"},{"type":"function","title":"Spooks.WorkflowEngine.run_workflow/1","doc":"Runs the agentic workflow for the given context.\n\nIF there is a repo, it will check for a checkpoint and resume the workflow.","ref":"Spooks.WorkflowEngine.html#run_workflow/1"},{"type":"function","title":"Spooks.WorkflowEngine.start_workflow/1","doc":"Starts a workflow for the given context. Ignores any existing checkpoints.","ref":"Spooks.WorkflowEngine.html#start_workflow/1"},{"type":"extras","title":"spooks","doc":"# spooks\nAn agentic workflow framework in Elixir","ref":"readme.html"},{"type":"extras","title":"Installation - spooks","doc":"You must run an ecto migration to create the `spooks_workflow_checkpoints` table if you plan on using checkpoints.\n\n```elixir\ndefmodule MyApp.Repo.Migrations.AddSpooksTables do\n  use Ecto.Migration\n\n  def down do\n    drop table(\"spooks_workflow_checkpoints\")\n  end\n\n  def up do\n    create table(\"spooks_workflow_checkpoints\") do\n      add :workflow_identifier, :string\n      add :workflow_module, :string\n      add :workflow_context, :map\n      add :workflow_event_module, :string\n      add :workflow_event, :map\n      add :checkpoint_timeout, :naive_datetime\n\n      timestamps()\n    end\n\n    create unique_index(\"spooks_workflow_checkpoints\", [:workflow_identifier])\n  end\nend\n\n```\n\nIf [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `spooks` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:spooks, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Run agents in a supervision tree - spooks","doc":"In your `application.ex` file add an agent runner for each agent:\n\n```elixir \nSupervisor.child_spec(\n  {Spooks.SpooksAgentRunner,\n    repo: MyApp.Repo,\n    check_time_in_minutes: 1,\n    workflow_module_name: MyApp.Agent.MyWorkflow,\n    llm: MyApp.MyLLMClient,\n    checkpoints_enabled: false\n  },\n  id: make_ref()\n)\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#run-agents-in-a-supervision-tree"},{"type":"extras","title":"Usage - spooks","doc":"Create your own workflow! Be sure you include the following line in your workflow module:\n\n```elixir\nuse Spooks.Workflow\n```\n\nCreate a struct for each event in your workflow. You can add whichever fields you like to your struct.\n\n> [!NOTE]\n> Note that all your events must `@derive Jason.Encoder` because they are saved to the database checkpoints.\n\n```elixir\ndefmodule MyApp.MyCustomEvent do\n  @derive Jason.Encoder\n  defstruct []\nend\n```\n\nIn your workflow, add a function for each event. The name of the function *must* be the same as the event name only with underscores and with the final `_event` replaced with `_step`. Your function must take 2 arguments. The event and the context. It must return either the `{:ok, next_event, updated_ctx}` or `{:error, reason}` tuple.\n\nFor example:\n\n```elixir\ndef my_custom_step(event, ctx) do\n  next_event = ...\n  udpated_ctx = ...\n  {:ok, next_event, updated_ctx}\nend\n```\n\nYou _should_ add a `@step` annotation to your step functions. This is used for generating diagrams of your agentic workflow. \n\n`in` must be\n\n- an event module name \n\n`out` can be \n\n- nil (the end of the agentic workflow)\n- an event module name \n- a list of event module names (for branching)\n\n```elixir\n@step %Step{in: MyFirstEvent, out: MySecondEvent}\ndef my_first_step(event, ctx) do\n  ...\nend\n\n@step %Step{in: MySecondEvent, out: [MyThirdEvent,StopEvent]}\ndef my_second_step(event, ctx) do\n  ...\nend\n\n@step %Step{in: MyFirstEvent, out: nil}\ndef my_last_step(event, ctx) do\n  {:ok, nil, ctx}\nend\n```\n\nThere are two built in events for `Spooks.Event.StartEvent` and `Spooks.Event.EndEvent`.\n\nIf you would like to add data or get data from the context you should use the following functions:\n\n> [!HINT]\n> You can also use a list of keys for `put_data` and `get_data` for nested data structures.\n\n```elixir\n@step %Step{in: MyFirstEvent, out: MySecondEvent}\ndef my_first_step(event, ctx) do\n  new_ctx = Spooks.Context.SpooksContext.put_data(:greeting, \"hello world!\")\n  {:ok, %MySecondEvent{}, new_ctx}\nend\n\n@step %Step{in: MySecondEvent, out: MyThirdEvent}\ndef my_second_step(event, ctx) do\n  custom_greeting = Spooks.Context.SpooksContext.get_data(:greeting)\n  IO.puts(custom_greeting)\n  {:ok, %MyThirdEvent{}, ctx}\nend\n```\n\nIf you wish to save checkpoints after each step, pass in your repository to the workflow context.\n\n```elixir\nworkflow = Spooks.Sample.SampleWorkflow\nrepo = MyApp.Repo\n\nworkflow_context = Spooks.Context.SpooksContext.new(workflow, repo)\nSpooks.WorkflowEngine.run_workflow(workflow_context)\n```\n\nIf you do not wish to save checkpoints:\n\n```elixir\nworkflow = Spooks.Sample.SampleWorkflow\nworkflow_context = Spooks.Context.SpooksContext.new(workflow, nil)\n\nSpooks.WorkflowEngine.run_workflow(workflow_context)\n```","ref":"readme.html#usage"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.1.3 (2024-12-07) - Changelog","doc":"Adding supervision tree example to README","ref":"changelog.html#v0-1-3-2024-12-07"},{"type":"extras","title":"v0.1.2 (2024-12-07) - Changelog","doc":"Adding code to generate text for a mermaid diagram of a workflow.","ref":"changelog.html#v0-1-2-2024-12-07"},{"type":"extras","title":"v0.1.1 (2024-12-06) - Changelog","doc":"Using `checkpoints_enabled` in the context instead of the presence of a repo.","ref":"changelog.html#v0-1-1-2024-12-06"},{"type":"extras","title":"v0.1.0 (2024-11-27) - Changelog","doc":"Initial release","ref":"changelog.html#v0-1-0-2024-11-27"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}